using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using System;
using WK_KLI_LAPS_Service.App_Data;
using WK_KLI_LAPS_Service.Models.Master;

namespace WK_KLI_LAPS_Service.Controllers.Master.Track
{
    [Route("api/[controller]")]
    [ApiController]
    public class TrackApiController : ControllerBase
    {
        CommonRepository oCommonRepository = new CommonRepository();

        private ITrackService _Trackservices;
        public TrackApiController(ITrackService TrackServices)
        {
            _Trackservices = TrackServices;

        }

        [Authorize]
        [HttpGet]
        //Code to retrieve all data
        public IActionResult GetAll()
        {
            var _list = _Trackservices.GetAll();
            return Ok(_list);
        }

        [Authorize]
        [HttpGet("GetActive")]
        //Code to retrieve active data
        public IActionResult GetActive()
        {
            var _list = _Trackservices.GetActive();
            return Ok(_list);
        }
        //Code to add new record
        [Authorize]
        [HttpPost("Add")]
        public IActionResult Add([FromBody] trackModel otrackModel)
        {

            int retval = 0;
            try
            {
                retval = _Trackservices.Add(otrackModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }
        //Code to update specific record
        [Authorize]
        [HttpPost("Update")]
        public IActionResult Update([FromBody] trackModel otrackModel)
        {
            int retval = 0;
            try
            {
                retval = _Trackservices.Edit(otrackModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }
        //Code to activate or deactivate specific record
        [Authorize]
        [HttpPost("activeordeactive")]
        public IActionResult Delete([FromBody] trackModel otrackModel)
        {
            int retval = 0;
            try
            {
                retval = _Trackservices.Delete(otrackModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }
        }
    }
}